]> git.saurik.com Git - apt.git/blame - test/integration/framework
keep not installed garbage packages uninstalled instead of showing
[apt.git] / test / integration / framework
CommitLineData
8d876415
DK
1#!/bin/sh -- # no runable script, just for vi
2
3# we all like colorful messages
4CERROR="\e[1;31m" # red
5CWARNING="\e[1;33m" # yellow
6CMSG="\e[1;32m" # green
7CINFO="\e[1;96m" # light blue
8CDEBUG="\e[1;94m" # blue
9CNORMAL="\e[0;39m" # default system console color
10CDONE="\e[1;32m" # green
11CPASS="\e[1;32m" # green
12CFAIL="\e[1;31m" # red
13CCMD="\e[1;35m" # pink
14
15msgdie() { echo "${CERROR}E: $1${CNORMAL}" >&2; exit 1; }
16msgwarn() { echo "${CWARNING}W: $1${CNORMAL}" >&2; }
17msgmsg() { echo "${CMSG}$1${CNORMAL}" >&2; }
18msginfo() { echo "${CINFO}I: $1${CNORMAL}" >&2; }
19msgdebug() { echo "${CDEBUG}D: $1${CNORMAL}" >&2; }
20msgdone() { echo "${CDONE}DONE${CNORMAL}" >&2; }
21msgnwarn() { echo -n "${CWARNING}W: $1${CNORMAL}" >&2; }
22msgnmsg() { echo -n "${CMSG}$1${CNORMAL}" >&2; }
23msgninfo() { echo -n "${CINFO}I: $1${CNORMAL}" >&2; }
24msgndebug() { echo -n "${CDEBUG}D: $1${CNORMAL}" >&2; }
25msgtest() { echo -n "${CINFO}$1 ${CCMD}$(echo "$2" | sed -e 's/^aptc/apt-c/' -e 's/^aptg/apt-g/' -e 's/^aptf/apt-f/')${CINFO} …${CNORMAL} " >&2; }
26msgpass() { echo "${CPASS}PASS${CNORMAL}" >&2; }
27msgskip() { echo "${CWARNING}SKIP${CNORMAL}" >&2; }
28msgfail() { echo "${CFAIL}FAIL${CNORMAL}" >&2; }
29
30# enable / disable Debugging
fc89263e
DK
31MSGLEVEL=${MSGLEVEL:-3}
32if [ $MSGLEVEL -le 0 ]; then
33 msgdie() { true; }
34fi
35if [ $MSGLEVEL -le 1 ]; then
36 msgwarn() { true; }
37 msgnwarn() { true; }
38fi
39if [ $MSGLEVEL -le 2 ]; then
40 msgmsg() { true; }
41 msgnmsg() { true; }
42fi
43if [ $MSGLEVEL -le 3 ]; then
44 msginfo() { true; }
45 msgninfo() { true; }
46fi
47if [ $MSGLEVEL -le 4 ]; then
48 msgdebug() { true; }
49 msgndebug() { true; }
50fi
51msgdone() {
52 if [ "$1" = "debug" -a $MSGLEVEL -le 4 ] ||
53 [ "$1" = "info" -a $MSGLEVEL -le 3 ] ||
54 [ "$1" = "msg" -a $MSGLEVEL -le 2 ] ||
55 [ "$1" = "warn" -a $MSGLEVEL -le 1 ] ||
56 [ "$1" = "die" -a $MSGLEVEL -le 0 ]; then
57 true;
58 else
59 echo "${CDONE}DONE${CNORMAL}" >&2;
60 fi
61}
8d876415
DK
62
63runapt() {
64 msgdebug "Executing: ${CCMD}$*${CDEBUG} "
7d0627b6
DK
65 if [ -f ./aptconfig.conf ]; then
66 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
4b2a4ab8
MV
67 elif [ -f ../aptconfig.conf ]; then
68 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
7d0627b6
DK
69 else
70 LD_LIBRARY_PATH=${BUILDDIRECTORY} ${BUILDDIRECTORY}/$*
71 fi
8d876415
DK
72}
73aptconfig() { runapt apt-config $*; }
74aptcache() { runapt apt-cache $*; }
75aptget() { runapt apt-get $*; }
76aptftparchive() { runapt apt-ftparchive $*; }
1f8b2599 77aptkey() { runapt apt-key $*; }
158fda31
DK
78dpkg() {
79 $(which dpkg) --root=${TMPWORKINGDIRECTORY}/rootdir --force-not-root --force-bad-path --log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log $*
80}
b6b5a542
DK
81aptitude() {
82 if [ -f ./aptconfig.conf ]; then
83 APT_CONFIG=aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
84 elif [ -f ../aptconfig.conf ]; then
85 APT_CONFIG=../aptconfig.conf LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
86 else
87 LD_LIBRARY_PATH=${BUILDDIRECTORY} $(which aptitude) $*
88 fi
89}
8d876415
DK
90
91setupenvironment() {
75954ae2 92 TMPWORKINGDIRECTORY=$(mktemp -d)
8f8169ac 93 local TESTDIR=$(readlink -f $(dirname $0))
3cbbda3c 94 msgninfo "Preparing environment for ${CCMD}$(basename $0)${CINFO} in ${TMPWORKINGDIRECTORY}… "
8f8169ac 95 BUILDDIRECTORY="${TESTDIR}/../../build/bin"
8d876415
DK
96 test -x "${BUILDDIRECTORY}/apt-get" || msgdie "You need to build tree first"
97 local OLDWORKINGDIRECTORY=$(pwd)
f213b6ea
DK
98 CURRENTTRAP="cd /; rm -rf $TMPWORKINGDIRECTORY; cd $OLDWORKINGDIRECTORY"
99 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
8d876415 100 cd $TMPWORKINGDIRECTORY
cd725954 101 mkdir rootdir aptarchive keys
8d876415 102 cd rootdir
b29c3712
DK
103 mkdir -p etc/apt/apt.conf.d etc/apt/sources.list.d etc/apt/trusted.gpg.d etc/apt/preferences.d
104 mkdir -p var/cache var/lib var/log
cffea9af 105 mkdir -p var/lib/dpkg/info var/lib/dpkg/updates var/lib/dpkg/triggers
2c6baa5a 106 local STATUSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/status-/' -e 's/^skip-/status-/')
8f8169ac
DK
107 if [ -f "${TESTDIR}/${STATUSFILE}" ]; then
108 cp "${TESTDIR}/${STATUSFILE}" var/lib/dpkg/status
109 else
110 touch var/lib/dpkg/status
111 fi
cd725954 112 touch var/lib/dpkg/available
8d876415
DK
113 mkdir -p usr/lib/apt
114 ln -s ${BUILDDIRECTORY}/methods usr/lib/apt/methods
115 cd ..
2c6baa5a 116 local PACKAGESFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Packages-/' -e 's/^skip-/Packages-/')
8f8169ac
DK
117 if [ -f "${TESTDIR}/${PACKAGESFILE}" ]; then
118 cp "${TESTDIR}/${PACKAGESFILE}" aptarchive/Packages
8f8169ac 119 fi
4a4ea26c
AM
120 local SOURCESSFILE=$(echo "$(basename $0)" | sed -e 's/^test-/Sources-/' -e 's/^skip-/Sources-/')
121 if [ -f "${TESTDIR}/${SOURCESSFILE}" ]; then
122 cp "${TESTDIR}/${SOURCESSFILE}" aptarchive/Sources
4a4ea26c 123 fi
cd725954
DK
124 cp $(find $TESTDIR -name '*.pub' -o -name '*.sec') keys/
125 ln -s ${TMPWORKINGDIRECTORY}/keys/joesixpack.pub rootdir/etc/apt/trusted.gpg.d/joesixpack.gpg
cffea9af 126 echo "Dir \"${TMPWORKINGDIRECTORY}/rootdir\";" > aptconfig.conf
94eb3bee 127 echo "Dir::state::status \"${TMPWORKINGDIRECTORY}/rootdir/var/lib/dpkg/status\";" >> aptconfig.conf
8d876415
DK
128 echo "Debug::NoLocking \"true\";" >> aptconfig.conf
129 echo "APT::Get::Show-User-Simulation-Note \"false\";" >> aptconfig.conf
f425d4d5 130 echo "Dir::Bin::Methods \"${BUILDDIRECTORY}/methods\";" >> aptconfig.conf
cffea9af
DK
131 echo "Dir::Bin::dpkg \"fakeroot\";" >> aptconfig.conf
132 echo "DPKG::options:: \"dpkg\";" >> aptconfig.conf
133 echo "DPKG::options:: \"--root=${TMPWORKINGDIRECTORY}/rootdir\";" >> aptconfig.conf
134 echo "DPKG::options:: \"--force-not-root\";" >> aptconfig.conf
135 echo "DPKG::options:: \"--force-bad-path\";" >> aptconfig.conf
136 echo "DPKG::options:: \"--log=${TMPWORKINGDIRECTORY}/rootdir/var/log/dpkg.log\";" >> aptconfig.conf
8d876415
DK
137 export LC_ALL=C
138 msgdone "info"
139}
140
141configarchitecture() {
142 local CONFFILE=rootdir/etc/apt/apt.conf.d/01multiarch.conf
143 echo "APT::Architecture \"$1\";" > $CONFFILE
144 shift
145 while [ -n "$1" ]; do
146 echo "APT::Architectures:: \"$1\";" >> $CONFFILE
147 shift
148 done
149}
150
75954ae2 151setupsimplenativepackage() {
ce9864a8
DK
152 local NAME="$1"
153 local ARCH="$2"
154 local VERSION="$3"
155 local RELEASE="${4:-unstable}"
156 local DEPENDENCIES="$5"
157 local DESCRIPTION="$6"
b7899b00
DK
158 local SECTION="${7:-others}"
159 local DISTSECTION
160 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
161 DISTSECTION="main"
162 else
163 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
164 fi
ce9864a8
DK
165 local BUILDDIR=incoming/${NAME}-${VERSION}
166 mkdir -p ${BUILDDIR}/debian/source
167 cd ${BUILDDIR}
168 echo "* most suckless software product ever" > FEATURES
b7899b00
DK
169 test -e debian/copyright || echo "Copyleft by Joe Sixpack $(date +%Y)" > debian/copyright
170 test -e debian/changelog || echo "$NAME ($VERSION) $RELEASE; urgency=low
ce9864a8
DK
171
172 * Initial release
173
b7899b00
DK
174 -- Joe Sixpack <joe@example.org> $(date -R)" > debian/changelog
175 test -e debian/control || echo "Source: $NAME
176Section: $SECTION
ce9864a8
DK
177Priority: optional
178Maintainer: Joe Sixpack <joe@example.org>
179Build-Depends: debhelper (>= 7)
180Standards-Version: 3.9.1
181
182Package: $NAME
b7899b00 183Architecture: $ARCH" > debian/control
ce9864a8
DK
184 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> debian/control
185 if [ -z "$DESCRIPTION" ]; then
186 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
187 If you find such a package installed on your system,
188 YOU did something horribly wrong! They are autogenerated
189 und used only by testcases for APT and surf no other propose…" >> debian/control
190 else
191 echo "Description: $DESCRIPTION" >> debian/control
192 fi
b7899b00
DK
193 test -e debian/compat || echo "7" > debian/compat
194 test -e debian/source/format || echo "3.0 (native)" > debian/source/format
ce9864a8 195 test -e debian/rules || cp /usr/share/doc/debhelper/examples/rules.tiny debian/rules
75954ae2
DK
196 cd - > /dev/null
197}
198
199buildsimplenativepackage() {
200 local NAME="$1"
201 local ARCH="$2"
202 local VERSION="$3"
203 local RELEASE="${4:-unstable}"
204 local DEPENDENCIES="$5"
205 local DESCRIPTION="$6"
206 local SECTION="${7:-others}"
207 local DISTSECTION
208 if [ "$SECTION" = "$(echo "$SECTION" | cut -d'/' -f 2)" ]; then
209 DISTSECTION="main"
210 else
211 DISTSECTION="$(echo "$SECTION" | cut -d'/' -f 1)"
212 fi
213 setupsimplenativepackage "$NAME" "$ARCH" "$VERSION" "$RELEASE" "$DEPENDENCIES" "$DESCRIPTION" "$SECTION"
214 buildpackage "incoming/${NAME}-${VERSION}" "$RELEASE" "$DISTSECTION"
215 rm -rf "incoming/${NAME}-${VERSION}"
216}
217
218buildpackage() {
219 local BUILDDIR=$1
220 local RELEASE=$2
221 local SECTION=$3
222 msgninfo "Build package $(echo "$BUILDDIR" | grep -o '[^/]*$') for ${RELEASE} in ${SECTION}… "
223 cd $BUILDDIR
224 if [ "$ARCH" = "all" ]; then
225 ARCH="$(dpkg-architecture -qDEB_HOST_ARCH 2> /dev/null)"
226 fi
b7899b00
DK
227 local BUILT="$(dpkg-buildpackage -uc -us -a$ARCH 2> /dev/null)"
228 local PKGS="$( echo "$BUILT" | grep '^dpkg-deb: building package' | cut -d'/' -f 2 | sed -e "s#'\.##")"
5ed56f93 229 local SRCS="$( echo "$BUILT" | grep '^dpkg-source: info: building' | grep -o '[a-z0-9._+~-]*$')"
ce9864a8 230 cd - > /dev/null
b7899b00 231 for PKG in $PKGS; do
75954ae2 232 echo "pool/${PKG}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.pkglist
b7899b00
DK
233 done
234 for SRC in $SRCS; do
75954ae2 235 echo "pool/${SRC}" >> ${TMPWORKINGDIRECTORY}/incoming/${RELEASE}.${SECTION}.srclist
b7899b00 236 done
cffea9af 237 msgdone "info"
ce9864a8
DK
238}
239
240buildaptarchive() {
ce9864a8
DK
241 if [ -d incoming ]; then
242 buildaptarchivefromincoming $*
243 else
244 buildaptarchivefromfiles $*
245 fi
246}
247
248createaptftparchiveconfig() {
249 local ARCHS="$(find pool/ -name '*.deb' | grep -oE '_[a-z0-9-]+\.deb$' | sort | uniq | sed -e '/^_all.deb$/ d' -e 's#^_\([a-z0-9-]*\)\.deb$#\1#' | tr '\n' ' ')"
158fda31
DK
250 if [ -z "$ARCHS" ]; then
251 # the pool is empty, so we will operate on faked packages - let us use the configured archs
252 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
253 fi
ce9864a8
DK
254 echo -n 'Dir {
255 ArchiveDir "' >> ftparchive.conf
256 echo -n $(readlink -f .) >> ftparchive.conf
257 echo -n '";
258 CacheDir "' >> ftparchive.conf
259 echo -n $(readlink -f ..) >> ftparchive.conf
260 echo -n '";
b7899b00
DK
261 FileListDir "' >> ftparchive.conf
262 echo -n $(readlink -f pool/) >> ftparchive.conf
263 echo -n '";
264};
265Default {
266 Packages::Compress ". gzip bzip2 lzma";
267 Sources::Compress ". gzip bzip2 lzma";
268 Contents::Compress ". gzip bzip2 lzma";
ce9864a8
DK
269};
270TreeDefault {
271 Directory "pool/";
272 SrcDirectory "pool/";
273};
274APT {
275 FTPArchive {
276 Release {
277 Origin "joesixpack";
278 Label "apttestcases";
279 Suite "unstable";
280 Description "repository with dummy packages";
281 Architectures "' >> ftparchive.conf
282 echo -n "$ARCHS" >> ftparchive.conf
283 echo 'source";
284 };
285 };
286};' >> ftparchive.conf
b7899b00
DK
287 for DIST in $(find ./pool/ -maxdepth 1 -name '*.pkglist' -type f | cut -d'/' -f 3 | cut -d'.' -f 1 | sort | uniq); do
288 echo -n 'tree "dists/' >> ftparchive.conf
289 echo -n "$DIST" >> ftparchive.conf
290 echo -n '" {
ce9864a8
DK
291 Architectures "' >> ftparchive.conf
292 echo -n "$ARCHS" >> ftparchive.conf
b7899b00
DK
293 echo -n 'source";
294 FileList "' >> ftparchive.conf
295 echo -n "${DIST}.\$(SECTION).pkglist" >> ftparchive.conf
296 echo -n '";
297 SourceFileList "' >> ftparchive.conf
298 echo -n "${DIST}.\$(SECTION).srclist" >> ftparchive.conf
299 echo -n '";
300 Sections "' >> ftparchive.conf
301 echo -n "$(find ./pool/ -maxdepth 1 -name "${DIST}.*.pkglist" -type f | cut -d'/' -f 3 | cut -d'.' -f 2 | sort | uniq | tr '\n' ' ')" >> ftparchive.conf
302 echo '";
ce9864a8 303};' >> ftparchive.conf
b7899b00 304 done
ce9864a8
DK
305}
306
307buildaptftparchivedirectorystructure() {
b7899b00
DK
308 local DISTS="$(grep -i '^tree ' ftparchive.conf | cut -d'/' -f 2 | sed -e 's#".*##')"
309 for DIST in $DISTS; do
310 local SECTIONS="$(grep -i -A 5 "dists/$DIST" ftparchive.conf | grep -i 'Sections' | cut -d'"' -f 2)"
311 for SECTION in $SECTIONS; do
312 local ARCHS="$(grep -A 5 "dists/$DIST" ftparchive.conf | grep Architectures | cut -d'"' -f 2 | sed -e 's#source##')"
313 for ARCH in $ARCHS; do
314 mkdir -p dists/${DIST}/${SECTION}/binary-${ARCH}
315 done
316 mkdir -p dists/${DIST}/${SECTION}/source
317 mkdir -p dists/${DIST}/${SECTION}/i18n
318 done
ce9864a8 319 done
ce9864a8
DK
320}
321
9b78cda6
DK
322insertpackage() {
323 local RELEASE="$1"
324 local NAME="$2"
325 local ARCH="$3"
326 local VERSION="$4"
327 local DEPENDENCIES="$5"
328 local ARCHS="$ARCH"
329 if [ "$ARCHS" = "all" ]; then
330 ARCHS="$(aptconfig dump | grep APT::Architecture | cut -d'"' -f 2 | sed '/^$/ d' | sort | uniq | tr '\n' ' ')"
331 fi
332 for BUILDARCH in $ARCHS; do
333 local PPATH="aptarchive/dists/${RELEASE}/main/binary-${BUILDARCH}"
334 mkdir -p $PPATH aptarchive/dists/${RELEASE}/main/source
335 touch aptarchive/dists/${RELEASE}/main/source/Sources
336 local FILE="${PPATH}/Packages"
337 echo "Package: $NAME
338Priority: optional
339Section: other
340Installed-Size: 23356
341Maintainer: Joe Sixpack <joe@example.org>
342Architecture: $ARCH
343Version: $VERSION" >> $FILE
344 test -z "$DEPENDENCIES" || echo "$DEPENDENCIES" >> $FILE
345 echo "Description: an autogenerated dummy ${NAME}=${VERSION}/${RELEASE}
346 If you find such a package installed on your system,
347 YOU did something horribly wrong! They are autogenerated
348 und used only by testcases for APT and surf no other propose…
349" >> $FILE
350 done
351}
352
ce9864a8 353buildaptarchivefromincoming() {
3cbbda3c 354 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on incoming packages…"
ce9864a8
DK
355 cd aptarchive
356 [ -e pool ] || ln -s ../incoming pool
357 [ -e ftparchive.conf ] || createaptftparchiveconfig
358 [ -e dists ] || buildaptftparchivedirectorystructure
b7899b00 359 msgninfo "\tGenerate Packages, Sources and Contents files… "
ce9864a8 360 aptftparchive -qq generate ftparchive.conf
ce9864a8
DK
361 cd - > /dev/null
362 msgdone "info"
9b78cda6 363 generatereleasefiles
ce9864a8
DK
364}
365
366buildaptarchivefromfiles() {
3cbbda3c 367 msginfo "Build APT archive for ${CCMD}$(basename $0)${CINFO} based on prebuild files…"
9b78cda6
DK
368 find aptarchive -name 'Packages' -o -name 'Sources' | while read line; do
369 msgninfo "\t${line} file… "
370 cat ${line} | gzip > ${line}.gz
371 cat ${line} | bzip2 > ${line}.bz2
372 cat ${line} | lzma > ${line}.lzma
8d876415 373 msgdone "info"
9b78cda6
DK
374 done
375 generatereleasefiles
376}
377
378generatereleasefiles() {
379 msgninfo "\tGenerate Release files… "
380 if [ -e aptarchive/dists ]; then
381 for dir in $(find ./aptarchive/dists -mindepth 1 -maxdepth 1 -type d); do
35faae11
DK
382 local CODENAME="$(echo "$dir" | cut -d'/' -f 4)"
383 aptftparchive -qq release $dir -o APT::FTPArchive::Release::Codename="${CODENAME}" | sed -e '/0 Release$/ d' > $dir/Release # remove the self reference
384 if [ "$CODENAME" = "experimental" ]; then
385 sed -i '/^Date: / a\
386NotAutomatic: yes' $dir/Release
387 fi
9b78cda6
DK
388 done
389 else
390 aptftparchive -qq release ./aptarchive | sed -e '/0 Release$/ d' > aptarchive/Release # remove the self reference
8d876415 391 fi
b7899b00 392 msgdone "info"
8d876415
DK
393}
394
b7899b00
DK
395setupdistsaptarchive() {
396 local APTARCHIVE=$(readlink -f ./aptarchive)
397 rm -f root/etc/apt/sources.list.d/apt-test-*-deb.list
398 rm -f root/etc/apt/sources.list.d/apt-test-*-deb-src.list
399 for DISTS in $(find ./aptarchive/dists/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 4); do
400 SECTIONS=$(find ./aptarchive/dists/${DISTS}/ -mindepth 1 -maxdepth 1 -type d | cut -d'/' -f 5 | tr '\n' ' ')
401 msgninfo "\tadd deb and deb-src sources.list lines for ${CCMD}${DISTS} ${SECTIONS}${CINFO}… "
402 echo "deb file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb.list
403 echo "deb-src file://$APTARCHIVE $DISTS $SECTIONS" > rootdir/etc/apt/sources.list.d/apt-test-${DISTS}-deb-src.list
404 msgdone "info"
405 done
406}
407
408setupflataptarchive() {
ce9864a8 409 local APTARCHIVE=$(readlink -f ./aptarchive)
8d876415
DK
410 if [ -f ${APTARCHIVE}/Packages ]; then
411 msgninfo "\tadd deb sources.list line… "
412 echo "deb file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
413 msgdone "info"
414 else
415 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb.list
416 fi
417 if [ -f ${APTARCHIVE}/Sources ]; then
418 msgninfo "\tadd deb-src sources.list line… "
419 echo "deb-src file://$APTARCHIVE /" > rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
420 msgdone "info"
421 else
422 rm -f rootdir/etc/apt/sources.list.d/apt-test-archive-deb-src.list
423 fi
b7899b00
DK
424}
425
426setupaptarchive() {
427 buildaptarchive
428 if [ -e aptarchive/dists ]; then
429 setupdistsaptarchive
430 else
431 setupflataptarchive
432 fi
f213b6ea 433 signreleasefiles
cd725954 434 msgninfo "\tSync APT's cache with the archive… "
8d876415 435 aptget update -qq
cd725954 436 msgdone "info"
8d876415
DK
437}
438
f213b6ea
DK
439signreleasefiles() {
440 local SIGNER="${1:-Joe Sixpack}"
441 msgninfo "\tSign archive with $SIGNER key… "
442 local SECKEYS=""
443 for KEY in $(find keys/ -name '*.sec'); do
444 SECKEYS="$SECKEYS --secret-keyring $KEY"
445 done
446 local PUBKEYS=""
447 for KEY in $(find keys/ -name '*.pub'); do
448 PUBKEYS="$PUBKEYS --keyring $KEY"
449 done
450 for RELEASE in $(find aptarchive/ -name Release); do
451 gpg --yes --no-default-keyring $SECKEYS $PUBKEYS --default-key "$SIGNER" -abs -o ${RELEASE}.gpg ${RELEASE}
452 done
453 msgdone "info"
454}
455
456changetowebserver() {
457 if which weborf > /dev/null; then
458 weborf -xb aptarchive/ 2>&1 > /dev/null &
0dc05bf0 459 CURRENTTRAP="kill $!; $CURRENTTRAP"
f213b6ea
DK
460 trap "$CURRENTTRAP" 0 HUP INT QUIT ILL ABRT FPE SEGV PIPE TERM
461 local APTARCHIVE="file://$(readlink -f ./aptarchive)"
462 for LIST in $(find rootdir/etc/apt/sources.list.d/ -name 'apt-test-*.list'); do
463 sed -i $LIST -e "s#$APTARCHIVE#http://localhost:8080/#"
464 done
465 return 0
466 fi
467 return 1
468}
469
470checkdiff() {
8d876415
DK
471 local DIFFTEXT="$($(which diff) -u $* | sed -e '/^---/ d' -e '/^+++/ d' -e '/^@@/ d')"
472 if [ -n "$DIFFTEXT" ]; then
473 echo
474 echo "$DIFFTEXT"
475 return 1
476 else
477 return 0
478 fi
479}
480
75954ae2
DK
481testfileequal() {
482 local FILE="$1"
483 shift
484 msgtest "Test for correctness of file" "$FILE"
485 if [ -z "$*" ]; then
f213b6ea 486 echo -n "" | checkdiff $FILE - && msgpass || msgfail
75954ae2 487 else
f213b6ea 488 echo "$*" | checkdiff $FILE - && msgpass || msgfail
75954ae2
DK
489 fi
490}
491
8d876415
DK
492testequal() {
493 local COMPAREFILE=$(mktemp)
494 echo "$1" > $COMPAREFILE
495 shift
496 msgtest "Test for equality of" "$*"
f213b6ea 497 $* 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8e86786b 498 rm $COMPAREFILE
8d876415
DK
499}
500
685625bd
DK
501testequalor2() {
502 local COMPAREFILE1=$(mktemp)
503 local COMPAREFILE2=$(mktemp)
504 local COMPAREAGAINST=$(mktemp)
505 echo "$1" > $COMPAREFILE1
506 echo "$2" > $COMPAREFILE2
507 shift 2
508 msgtest "Test for equality OR of" "$*"
509 $* 2>&1 1> $COMPAREAGAINST
f213b6ea
DK
510 (checkdiff $COMPAREFILE1 $COMPAREAGAINST 1> /dev/null ||
511 checkdiff $COMPAREFILE2 $COMPAREAGAINST 1> /dev/null) && msgpass ||
512 ( echo "\n${CINFO}Diff against OR 1${CNORMAL}" "$(checkdiff $COMPAREFILE1 $COMPAREAGAINST)" \
513 "\n${CINFO}Diff against OR 2${CNORMAL}" "$(checkdiff $COMPAREFILE2 $COMPAREAGAINST)" &&
685625bd 514 msgfail )
8e86786b 515 rm $COMPAREFILE1 $COMPAREFILE2 $COMPAREAGAINST
685625bd
DK
516}
517
8d876415 518testshowvirtual() {
4bec02c2 519 local VIRTUAL="N: Can't select versions from package '$1' as it purely virtual"
8d876415
DK
520 local PACKAGE="$1"
521 shift
522 while [ -n "$1" ]; do
523 VIRTUAL="${VIRTUAL}
4bec02c2 524N: Can't select versions from package '$1' as it purely virtual"
8d876415
DK
525 PACKAGE="${PACKAGE} $1"
526 shift
527 done
528 msgtest "Test for virtual packages" "apt-cache show $PACKAGE"
529 VIRTUAL="${VIRTUAL}
4bec02c2 530N: No packages found"
8d876415
DK
531 local COMPAREFILE=$(mktemp)
532 local ARCH=$(dpkg-architecture -qDEB_HOST_ARCH_CPU)
533 eval `apt-config shell ARCH APT::Architecture`
534 echo "$VIRTUAL" | sed -e "s/:$ARCH//" -e 's/:all//' > $COMPAREFILE
e8379ba3 535 aptcache show -q=0 $PACKAGE 2>&1 | checkdiff $COMPAREFILE - && msgpass || msgfail
8e86786b 536 rm $COMPAREFILE
8d876415
DK
537}
538
539testnopackage() {
540 msgtest "Test for non-existent packages" "apt-cache show $*"
541 local SHOWPKG="$(aptcache show $* 2>&1 | grep '^Package: ')"
542 if [ -n "$SHOWPKG" ]; then
543 echo
544 echo "$SHOWPKG"
545 msgfail
546 return 1
547 fi
548 msgpass
549}
01a6e24c
DK
550
551testdpkginstalled() {
552 msgtest "Test for correctly installed package(s) with" "dpkg -l $*"
553 local PKGS="$(dpkg -l $* | grep '^[a-z]' | grep '^[^i]' | wc -l)"
554 if [ "$PKGS" != 0 ]; then
555 echo $PKGS
556 dpkg -l $* | grep '^[a-z]'
557 msgfail
558 return 1
559 fi
560 msgpass
561}
562
563testdpkgnoninstalled() {
564 msgtest "Test for correctly non-installed package(s) with" "dpkg -l $*"
565 local PKGS="$(dpkg -l $* | grep '^[a-z]' | grep '^[^u]' | wc -l)"
566 if [ "$PKGS" != 0 ]; then
567 echo
568 dpkg -l $* | grep '^[a-z]'
569 msgfail
570 return 1
571 fi
572 msgpass
573}